#ifndef DERIVED_H_
#define DERIVED_H_

#include <cstddef> // NULL
#include <iomanip>
#include <iostream>
#include <fstream>
#include <string>

#if defined(MYSERI)
#include <boost/archive/tmpdir.hpp>

#include <boost/archive/text_iarchive.hpp>
#include <boost/archive/text_oarchive.hpp>

#include <boost/serialization/base_object.hpp>
#include <boost/serialization/utility.hpp>
#include <boost/serialization/list.hpp>
#include <boost/serialization/assume_abstract.hpp>
#include <boost/serialization/export.hpp>
#endif

#include "base.h"
#include "base_observable.h"



/////////////////////////////////////////////////////////////
// Several kinds of bus stops
//
// illustrates serialization of derived types
//
class derived : public base
{
    int longitude;
    int latitude;
    std::string street1;
    std::string street2;
    base_observable* observable_p;

#if defined(MYSERI)
    friend class boost::serialization::access;
    template<class Archive>
      void serialize(Archive &ar, const unsigned int version)
    {
      // save/load base class information
      ar & boost::serialization::base_object<base>(*this);

      ar & longitude & latitude;
      ar & street1 & street2;
      ar & observable_p;
    }
#endif

public:
    void show_me();
    void update();
    derived();
    derived(const int & _lat, const int & _long,
	    const std::string & _s1, const std::string & _s2,
	    base_observable* observ_p);

};


#if defined(MYSERI)
BOOST_CLASS_EXPORT(derived)
#endif

#endif
