#ifndef DERIVED_1_H_
#define DERIVED_1_H_

#include <cstddef> // NULL
#include <iomanip>
#include <iostream>
#include <fstream>
#include <string>

#if defined(MYSERI)
#include <boost/archive/tmpdir.hpp>

#include <boost/archive/text_iarchive.hpp>
#include <boost/archive/text_oarchive.hpp>

#include <boost/serialization/base_object.hpp>
#include <boost/serialization/utility.hpp>
#include <boost/serialization/list.hpp>
#include <boost/serialization/assume_abstract.hpp>
#include <boost/serialization/export.hpp>
#endif


#include "base.h"
#include "base_observable.h"

//class observable;

/////////////////////////////////////////////////////////////
// Several kinds of bus stops
//
// illustrates serialization of derived types
//
class derived_1 : public base
{
    int longitude;
    int latitude;
    std::string street1;
    std::string street2;
    std::string street3;
    base_observable* observable_p;

#if defined(MYSERI)
    friend class boost::serialization::access;
    template<class Archive>
      void serialize(Archive &ar, const unsigned int version)
      {
	// save/load base class information
	ar & boost::serialization::base_object<base>(*this);
	
	ar & longitude & latitude;
        ar & street1 & street2 & street3;
	ar & observable_p;
      
      }
#endif    
public:
    void show_me();
    derived_1();
    derived_1(const int & _lat, const int & _long,
	      const std::string & _s1, const std::string & _s2,
	      const std::string & _s3,
	      base_observable* observ_p);
    void update();

};

#if defined(MYSERI)
BOOST_CLASS_EXPORT(derived_1)
#endif

#endif
