#include <string>

#include "derived.h"
#include "composite.h"
#include "derived_1.h"
#include "observable.h"

#if defined(MYSERI)
#include <boost/archive/tmpdir.hpp>

#include <boost/archive/text_iarchive.hpp>
#include <boost/archive/text_oarchive.hpp>
#endif

void save_schedule(const composite &s, const observable &o, const char * filename){

#if defined(MYSERI)
    // make an archive
    std::ofstream ofs(filename);
    boost::archive::text_oarchive oa(ofs);
    oa << o;
    oa << s;
#endif

}

void restore_schedule(composite &s, observable &o, const char * filename)
{


#if defined(MYSERI)
  // open the archive
  std::ifstream ifs(filename);
  boost::archive::text_iarchive ia(ifs);
  
  // restore the schedule from the archive
  ia >> o;
  ia >> s;
#endif

}


int main(int argc, char *argv[])
{   
  
  observable funny;
  composite my_comps;

  base *bs0 = NULL;
  base *bs1 = NULL;
  base *bs2 = NULL;
  base *bs3 = NULL;

#if defined(MYSERI)
  //  std::string filename(boost::archive::tmpdir());
  std::string filename = "demofile.txt";
#endif  

  if( argc != 2 ) {
    std::cout << "Please state --save or --load" << std::endl;
    return 1;
  }


  if( std::string(argv[1]) == "--save" ) {
    // fill in the data
    // make a few stops
    bs0 = new derived(
        34,
        134,
        "24th Street", "10th Avenue",
	&funny );
    bs1 = new derived(
        35,
        133,
        "State street", "Cathedral Vista Lane",
	&funny );

    bs2 = new derived_1(
        35,
        133,
        "State street", "Cathedral Vista Lane", "Mikael",
	&funny );


    bs3 = new derived_1(
        35,
        133,
        "State street", "Cathedral Vista Lane", "Mikael",
	&funny );

    my_comps.append(bs0);
    my_comps.append(bs1);
    my_comps.append(bs2);
    my_comps.append(bs3);

    funny.attach(bs0);

    funny.print();
    
    std::cout << std::endl;

    my_comps.print();
    std::cout << std::endl;
    std::cout << std::endl;


#if defined(MYSERI)
    // save the schedule
    save_schedule(my_comps, funny, filename.c_str());
#endif

  }
  
  else if( std::string(argv[1]) == "--load" ) {
  
    observable funny1;
    composite my_comps1;
    
    std::cout << "Reading back ...";
#if defined(MYSERI)
    restore_schedule(my_comps1, funny1, filename.c_str());
#endif
    std::cout << "done." << std::endl;
    
    funny1.print();

    std::cout << std::endl;
    my_comps1.print();
    std::cout << std::endl;
    std::cout << std::endl;


  }  

#if 0
  delete bs0;
  delete bs1;
  delete bs2;
  delete bs3;

#endif  
  
}
